%% ``The contents of this file are subject to the Erlang Public License,
%% Version 1.1, (the "License"); you may not use this file except in
%% compliance with the License. You should have received a copy of the
%% Erlang Public License along with this software. If not, it can be
%% retrieved via the world wide web at http://www.erlang.org/.
%% 
%% Software distributed under the License is distributed on an "AS IS"
%% basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
%% the License for the specific language governing rights and limitations
%% under the License.
%% 
%% The Initial Developer of the Original Code is Ericsson Utvecklings AB.
%% Portions created by Ericsson are Copyright 1999, Ericsson Utvecklings
%% AB. All Rights Reserved.''
%% 
%%     $Id$
%%
-module(io_SUITE).

-export([all/1]).

-export([init_per_testcase/2, fin_per_testcase/2]).

-export([error_1/1]).

-include("test_server.hrl").

% Default timetrap timeout (set in init_per_testcase).
-define(default_timeout, ?t:minutes(1)).

init_per_testcase(Case, Config) ->
    ?line Dog = ?t:timetrap(?default_timeout),
    [{watchdog, Dog} | Config].
fin_per_testcase(Case, Config) ->
    Dog = ?config(watchdog, Config),
    test_server:timetrap_cancel(Dog),
    ok.

all(doc) ->
    ["Test cases for io."];
all(suite) ->
    [error_1].

error_1(doc) ->
    ["Error cases for output"];
error_1(suite) ->
    [];
error_1(Config) when list(Config) ->
    %% We don't do erroneous output on stdout - the test server
    %% seems to catch that somehow.
    ?line PrivDir = ?config(priv_dir, Config),
    ?line File = filename:join(PrivDir, "slask"),
    ?line {ok, F1} = file:open(File, [write]),
    ?line {'EXIT', _} = (catch io:format(muttru, "hej", [])),
    ?line {'EXIT', _} = (catch io:format(F1, pelle, "hej")),
    ?line {'EXIT', _} = (catch io:format(F1, 1, "hej")),
    ?line {'EXIT', _} = (catch io:format(F1, "~p~", [kaka])),
    ?line {'EXIT', _} = (catch io:format(F1, "~m~n", [kaka])),

    %% This causes the file process to die, and it is linked to us,
    %% so we can't catch the error this easily.
%    ?line {'EXIT', _} = (catch io:put_chars(F1, 666)),

    ?line file:close(F1),
    ?line {'EXIT', _} = (catch io:format(F1, "~p", ["hej"])),
    ok.
